;==================================================================================
;                                v1.0
;==================================================================================
; Copyright (C)   , 2011 - 2012
;   
;----------------------------------------------------------------------------------

; :  ATtiny2313
;  : 4 ,  RC-

.include "tn2313def.inc"

.def mod0=R0
.def mod1=R1

.def cnt_L         =R3
.def cnt_H         =R4

.def temp1         =R16
.def temp2         =R17
.def temp3         =R18
.def temp4         =R19

.def digit         =R20
.def btn_flags     =R21

.def temp5         =R22
.def temp6         =R23
.def temp7         =R24
.def status        =R25

.def flags         =R27


.equ MINUTE        =60     ;

; 
.equ DIGITS        =3     ;  
.equ SEG7_PORT     =PORTB ;,    
.equ SEG7_ANOD     =PORTD ;,     

.equ LOAD_PORT     =PORTD ;,     
.equ LOAD_PIN      =6     ; ,     

.equ LED_PORT      =PORTA ;,     

; 
.equ BTN_PORT      =PIND  ;,    
.equ BTN_PORT_PIN  =4     ; ,    
.equ MAX_BNC_CNT   =20    ;      

.equ BTN_INC_PERIOD=83      ;       3 
                            ;(6*BTN_INC_PERIOD )
.equ BTN_INC_FAST_PERIOD=16 ;       3 
                            ;(6*BTN_INC_FAST_PERIOD )
.equ BTN_FAST_INC  =5       ; ""  ,  
                            ;  

.equ TRG_H_HYSTERESIS=1

;--------- --------
.equ F_BTN_1         =0b00000001
.equ F_BTN_2         =0b00000010
.equ F_BTN_3         =0b00000100

.equ F_TIMER0_INT    =0b00000001 
.equ F_OFF_TMR_ELAPS =0b00000010
.equ F_POINT_DIG_0   =0b00000100 ;   ""  0- 
.equ F_EXT_CTRL      =0b00001000 ;  " "
.equ F_AUTO_MD_LOAD  =0b00010000 ; ,   
.equ F_H_MIN_FALLING =0b00100000 ;      
.equ F_TIMER_DISABLE =0b01000000 ;     

;----- ----
.equ ST_DISPL_CUR_H    =0        ;  
.equ ST_SET_HIGH_H     =1        ;   
.equ ST_SET_LOW_H      =2
.equ ST_SET_RAISING_H  =3        ;   , 
                                 ;   
.equ ST_SET_FALLING_H  =4        ;   ,
                                 ;    
.equ ST_SET_DELAY      =5        ;  
.equ ST_MAX_STATUS     =5        ;   status                               
;------ ------
.equ MD_AUTO_MODE      =1        ; 
.equ MD_MANUAL_MODE    =2        ;  / 

;----------------------
;                     hgfedcba
.equ CH_SPACE      =0b11111111
.equ CH_HYPHEN     =0b10111111
.equ CH_E          =0b10000110
.equ CH_r          =0b10101111
.equ CH_H          =0b10001001
.equ CH_LH         =0b10001011
.equ CH_L          =0b11000111
.equ CH_A          =0b10001000
.equ CH_3          =0b10110000
.equ CH_Hp         =0b00001001
.equ CH_d          =0b10100001
.equ CH_t          =0b10000111
.equ CH_O          =0b11000000
.equ CH_n          =0b10101011
.equ CH_F          =0b10001110
.equ CH_RAISING    =0b10101101
.equ CH_FALLING    =0b10011011
.equ CH_START      =0b10110110
.equ CH_PSET       =0b01111111
.equ CH_1          =0b11111001

;----- --------
.equ LED_DARK      =0b000
.equ LED_RED       =0b001
.equ LED_GREEN     =0b010
.equ LED_YELLOW    =0b011

;--------------------  ------------------------------------
.equ SAMPLE_PERIOD =500   ;      
                          ;(2*SAMPLE_PERIOD )

.equ EXT_CTRL_CNT  =20   ;   
                          ;   INT_1

.equ NO_EXT_SIGNAL =10    ;    ,
                          ;  ,    

;----------------    -----------------------
.equ MAX_HIGH_H      =100
.equ MIN_HIGH_H      =30   ;     (%)

.equ MAX_LOW_H       =60
.equ MIN_LOW_H       =30

.equ MAX_VAL_RAISING =50   ;     (%/.)
.equ MIN_VAL_RAISING =1    ;     (%/.)

.equ MAX_VAL_FALLING =50   ;     (%/.)
.equ MIN_VAL_FALLING =1    ;     (%/.)

.equ MAX_VAL_DELAY   =60   ;    (.)
.equ MIN_VAL_DELAY   =0    ;    (.)


.macro LOAD_TOGGLE
       ;-------------    ------------------
	   ;   ,     
	   ;F_AUTO_MD_LOAD
		lds temp1, mode
		cpi temp1, MD_AUTO_MODE
		brne no_auto_mode

		ldi temp1, F_AUTO_MD_LOAD
		and temp1, flags
		breq load_turned_off
        sbi LOAD_PORT, LOAD_PIN           ; 
		rjmp no_auto_mode
load_turned_off:
        cbi LOAD_PORT, LOAD_PIN           ; 
no_auto_mode:        
       ;----------------------------------------------------------------------
.endm

.macro EXT_SIGNAL
;-----    --------------------
        lds temp1, Ext_Control_cnt
		cpi temp1, NO_EXT_SIGNAL
		brlo no_ext_control

		;dec temp1
		;sts Ext_Control_cnt, temp1
        
		;   
		ori flags, F_EXT_CTRL

		; 
		rcall Load_ON

		rjmp no_ext_control_2

no_ext_control:
        
		;   
		ldi temp1, F_EXT_CTRL
		and temp1, flags
		breq no_ext_control_2

        ;       
		;(Ext_Control_cnt  ,   F_EXT_CTRL   )
		; 
		rcall Start_Timer

		;   
        andi flags, ~F_EXT_CTRL
no_ext_control_2:
       ;-----------     ---------------

.endm

.macro BLINK_POINT
	   ;    
       ;    
		lds temp1, OFF_Timer_Val
		tst temp1
		breq no_blink_point
        
        ldi temp2, F_POINT_DIG_0
		eor flags, temp2
		rjmp blink_pnt
no_blink_point:
        andi flags, ~F_POINT_DIG_0
blink_pnt:
       ;    
.endm

;---------------------------------  ----------------------------------
.dseg 
 Display_Buf:       .byte DIGITS ; 
 debounce_cnts:     .byte 4      ; 4    
                                 ;   

 btn_inc_cnt:       .byte 1      ;     
                                 ;  3- 
 btn_fast_inc_cnt:  .byte 1      ;     ,
                                 ;     
 
 humidity:          .byte 1      ; 

 high_H:            .byte 1      ;  
 low_H:             .byte 1      ;  

 max_raising:       .byte 1      ;  
 min_falling:       .byte 1      ;  
 OFF_delay:         .byte 1      ; 
 Inc_Value_Buf:     .byte 1      ;     
 Inc_Value_Max:     .byte 1
 Inc_Value_Min:     .byte 1

 K_sens:            .byte 2      ;   
 H_offs:            .byte 2      ;(     )

 seconds:           .byte 1      ; 
 tmr_seconds:       .byte 1      ;    

 prev_H:            .byte 1      ; 
 dH_dt:             .byte 1      ;   (%/.)
 target_H:          .byte 1      ; 
 OFF_Timer_Val:     .byte 1      ;   (.)

 Ext_Control_cnt:       .byte 1      ;    

 mode:              .byte 1      ;

 H_array:           .byte 16      ;   
 H_array_i:         .byte 1      ;    
 timeout:           .byte 1      ;    
 timeout_cnt:       .byte 1      ;    
                                 ; 

;-------------------------------  ---------------------------------
.eseg

; 
eep_K_sens:        .dw 0x0152  ; K_sens
eep_H_offs:        .dw 0x01EF  ; H_offs
eep_OSCCAL:        .db 0x40    ;   RC-

; 
eep_high_H:        .db 90  ;     
eep_low_H:         .db 50  ;     
eep_max_raising:   .db 10  ;  
eep_min_falling:   .db 5   ;  
eep_OFF_delay:     .db 1   ; 

;-----------------------------------------------------------------------------------
.cseg
.org 0

;  
rjmp Reset        ;  
reti              ;INT_0 -    (    "INT0") 
rjmp INT_1        ;INT_1 -    (  "INT1") 
reti              ;Timer1_capt1 - /1, 
reti              ;Timer1_comp1 -   A 1- 
reti              ;Timer1_OVF1 -   1- 
reti              ;Timer0_OVF0 -   0- 
reti              ;UART_RX -       UART
reti              ;UART_UDRE -     UART
reti              ;UART_TX -      UART
reti              ;ANA_COMP -   
reti              ;     
reti              ;/1, ,  B
rjmp Timer0_compA ;/0, ,  A
reti              ;/0, ,  B
reti              ;USI   
reti              ;USI 
reti              ;EEPROM 
reti              ;  



;---------------------------------------------------------------------
reset:
       ;    RC- 
	   ldi temp2,eep_OSCCAL
       rcall EEPROM_read
	   out OSCCAL, temp1
      
      ;  -
	   ;  
       ldi temp1,0b011
	   out DDRA,temp1
       ;  B
	   ldi temp1,0b11111111
       out DDRB, temp1 ;   B  

	   sts target_H, temp1    ;target_H=0xFF    (  )
	   sts timeout_cnt, temp1 ;timeout_cnt=0xFF	(  )

       ;  D
       ldi temp1,0b01000111
       out DDRD, temp1 ;0-2  6   D  , 5  4  -  
 
      ;  
	   ldi temp1, 0x80
	   out ACSR, temp1

      ;  
       ldi temp1, 0x18
	   out WDTCR, temp1
	   ldi temp1, 0b00001001
	   out WDTCR, temp1

      ;  
	   ldi temp1, 0b10000000
	   out GIMSK, temp1

	   ldi temp1, 0b00001100
	   out MCUCR, temp1

	   sei ; 

	  ; 
       ldi temp1, RAMEND
       out SPL, temp1

	  ;  

	   clr cnt_L
	   clr cnt_H

	   ldi status,0                 ;  
	                                ;(  )
       ldi flags, 0
       ldi btn_flags, 0
	   ldi digit, 0

      ;    

	   sts btn_inc_cnt, status      ;    3
	   sts btn_fast_inc_cnt, status

	   sts prev_H, status

	   sts OFF_Timer_Val, status

	   sts Ext_Control_cnt, status

	   sts tmr_seconds, status

	   sts Humidity, status

	   sts debounce_cnts, status

           
       sts H_array_i, status

	   ; 4 
	   ldi temp2, 240           ;
	   sts timeout, temp2
           
	      
	   ldi temp2, MINUTE-1
	   sts seconds, temp2

	   ldi temp2, MD_AUTO_MODE
	   sts mode, temp2

	   ;   
	   ldi temp2, LED_GREEN
	   out LED_PORT, temp2
	   

	   ;     
	   ldi temp2, eep_high_H
	   rcall EEPROM_read
	   sts high_H, temp1

	   ;     
       ldi temp2, eep_low_H
	   rcall EEPROM_read
	   sts low_H, temp1

       ;     ,    
	   ldi temp2, eep_max_raising
	   rcall EEPROM_read
	   sts max_raising, temp1

	   ;     ,    
	   ldi temp2, eep_min_falling
	   rcall EEPROM_read
	   sts min_falling, temp1

	   ;     
	   ldi temp2, eep_OFF_delay
	   rcall EEPROM_read
	   sts OFF_delay, temp1

	   ;    
       ldi temp2, eep_K_sens
	   rcall EEPROM_read
	   sts K_sens, temp1
       
	   ldi temp2, eep_K_sens+1
	   rcall EEPROM_read
	   sts K_sens+1, temp1

	   ldi temp2, eep_H_offs
	   rcall EEPROM_read
	   sts H_offs, temp1
       
	   ldi temp2, eep_H_offs+1
	   rcall EEPROM_read
	   sts H_offs+1, temp1

	  ;  0
	   ldi temp1, 0x02
       out TCCR0A, temp1

       ldi temp1, 0x03
       out TCCR0B, temp1
       ldi temp1, 123
       out TCNT0, temp1
	   ldi temp1, 124
       out OCR0A, temp1

       ;  1	   	 
	   ;  1
	   ldi temp1, 0x07
	   out TCCR1B, temp1

      ;    0
	   ldi temp1, 0x01
	   out TIMSK, temp1


;========================   =======================
main:
        ldi temp1, F_TIMER0_INT   ;    0:
        and temp1, flags          ;-      0
		breq main                 ;-   ,                                    
		andi flags, ~F_TIMER0_INT ;     0 

	    wdr                       ;  
       
	    EXT_SIGNAL             ;   
		mov temp1, cnt_L
		andi temp1, 0x0F
		brne no_dec_ext_cnt

		lds temp1, Ext_Control_cnt
        cpi temp1, 0
		breq no_dec_ext_cnt
		dec temp1
		sts Ext_Control_cnt, temp1
no_dec_ext_cnt:

        LOAD_TOGGLE            ;    

	   ;   
	    ;      
	    cpi status, ST_DISPL_CUR_H	    
		brne no_displ_mode
		rcall Display_mode
no_displ_mode:

       ;---        ---
        ldi temp1, Low(SAMPLE_PERIOD)
		ldi temp2, High(SAMPLE_PERIOD)		
		cp cnt_L, temp1
		cpc cnt_H, temp2
		brlo main_no_sample
 
	   ;******  (SAMPLE_PERIOD+1)*2    :*****
        clr cnt_L  ;   
		clr cnt_H


        rcall Algorithm

		;  
		lds temp1, seconds
		inc temp1
        
		;,   1 
		cpi temp1, MINUTE
		brlo Minute_No_El

       ;++++++++++++  1 ,   :++++++++++++++++		

		rcall Vent_Control

        rcall WD_timeout    ; 
        
		clr temp1           ;  

Minute_No_El:
       ;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		sts seconds, temp1

       ;************************************************************************
main_no_sample:

       ;   
	   ldi temp1,1
	   add cnt_L,temp1
	   ldi temp1,0
	   adc cnt_H,temp1
       
       ; 	    
       rcall seg7_display


      ;----------- -------------
	   ldi ZL,Low(Buttons)   
       ldi ZH,High(Buttons)
       
       clr temp2                  ; 
       add ZL,digit               ; 0-  
       adc ZH,temp2
       
	   rcall Debounce         ; 
	  ;------------------------------------

	   ;   
		 inc digit

         cpi digit,DIGITS
         brlo seg7_no_inc_dig
         clr digit
seg7_no_inc_dig:
     

rjmp main
;==================================================================================

seg7_DC:
; -   
              ;     hgfedcba   hgfedcba
              .db 0b11000000,0b11111001	;0,1
              .db 0b10100100,0b10110000	;2,3
              .db 0b10011001,0b10010010	;4,5
              .db 0b10000010,0b11111000	;6,7
              .db 0b10000000,0b10010000	;8,9

;      
Buttons:
         rjmp Btn1
		 rjmp Btn2
         rjmp Btn3

;----   1-  ( /)------
Btn1:
         push temp1

		 mov temp1, btn_flags
		 andi temp1, F_BTN_1
		 brne Btn1_end
         
		 ; 
         lds temp1, mode
		 cpi temp1, MD_MANUAL_MODE
		 brne btn1_no_manual_md
		 ;   ,  
         ldi temp1, MD_AUTO_MODE
		 sts mode, temp1

		 rjmp btn1_end

btn1_no_manual_md:
         ;   ,  
         ldi temp1, MD_MANUAL_MODE
		 sts mode, temp1
         
		 ;    
		 sbis LOAD_PORT, LOAD_PIN
		 rjmp btn1_load_on
		 cbi LOAD_PORT, LOAD_PIN
		 rjmp btn1_end
btn1_load_on:
         sbi LOAD_PORT, LOAD_PIN

btn1_end:
         cpi status, ST_DISPL_CUR_H
	     brne btn1_no_displ_mode
		 rcall Display_mode
btn1_no_displ_mode:

		 pop temp1
ret

;-------------   2-  ()------------------------
Btn2:
         push temp1
		 push temp2
         
		 	 
		 mov temp1, btn_flags
		 andi temp1, F_BTN_2
		 brne Btn2_end
         
		 rcall Btn2_menu
       
Btn2_end:
         pop temp2
         pop temp1
ret

;-----------------------------------------------------------------------------
Btn2_menu:
         
		 inc status
		 cpi status, ST_MAX_STATUS+1
		 brlo Btn2_0
		 clr status
Btn2_0:	
       
	  ;        ,
	  ;   
		 
        ;    
		 cpi status, ST_DISPL_CUR_H
         brne Btn2_1

		 lds temp1, Inc_Value_Buf
		 sts OFF_Delay, temp1
         
		;    
		 ldi temp2, eep_OFF_Delay
		 ;lds temp1, OFF_Delay
		 rcall EEPROM_write

		 
         ;rcall Displ_Cur_H

		 rjmp Btn2_menu_end		
Btn2_1:		
		;     
		 cpi status, ST_SET_HIGH_H
         brne Btn2_2
         
		 ;  "H"
		 ldi temp1,CH_H
		 sts Display_Buf+0, temp1

		 lds temp1, high_H
		 sts Inc_Value_Buf, temp1
		 rcall put_2u

		 ldi temp1, MIN_HIGH_H
		 sts Inc_Value_Min, temp1

		 ldi temp1, MAX_HIGH_H
		 sts Inc_Value_Max, temp1

		 ;lds temp1, Inc_Value_Buf
		 

		 rjmp Btn2_menu_end

Btn2_2:
        ;     
         cpi status, ST_SET_LOW_H
		 brne Btn2_3

         lds temp1, Inc_Value_Buf
		 sts high_H, temp1
		 
		 ;    
		 ldi temp2, eep_high_H
		 ;lds temp1, high_H
		 rcall EEPROM_write

         ;  "h"
		 ldi temp1,CH_LH
		 sts Display_Buf+0, temp1

         lds temp1, low_H
		 sts Inc_Value_Buf, temp1
		 rcall put_2u

		 ldi temp1, MIN_LOW_H
		 sts Inc_Value_Min, temp1

		 ldi temp1, MAX_LOW_H
		 sts Inc_Value_Max, temp1

         rjmp Btn2_menu_end
Btn2_3:        
		;     
		 cpi status, ST_SET_RAISING_H
         brne Btn2_4

		 lds temp1, Inc_Value_Buf
		 sts low_H, temp1
		 
		 ;    
		 ldi temp2, eep_low_H
		 rcall EEPROM_write
         
		 ;  " "
		 ldi temp1,CH_RAISING
		 sts Display_Buf+0, temp1

		 lds temp1, max_raising
		 sts Inc_Value_Buf, temp1
		 rcall put_2u

		 ldi temp1, MIN_VAL_RAISING
		 sts Inc_Value_Min, temp1

		 ldi temp1, MAX_VAL_RAISING
		 sts Inc_Value_Max, temp1


		 rjmp Btn2_menu_end

Btn2_4:
         ;     
		 cpi status, ST_SET_FALLING_H
         brne Btn2_5

		 lds temp1, Inc_Value_Buf
		 sts max_raising, temp1

		 ;    
		 ldi temp2, eep_max_raising
		 rcall EEPROM_write
         
		 ;  " "
		 ldi temp1,CH_FALLING
		 sts Display_Buf+0, temp1

		 lds temp1, min_falling
         sts Inc_Value_Buf, temp1
		 rcall put_2u

		 ldi temp1, MIN_VAL_FALLING
		 sts Inc_Value_Min, temp1

		 ldi temp1, MAX_VAL_FALLING
		 sts Inc_Value_Max, temp1


		 rjmp Btn2_menu_end
Btn2_5:
         
		 ;    
		 cpi status, ST_SET_DELAY
         brne Btn2_menu_end
         
		 lds temp1, Inc_Value_Buf
		 sts min_falling, temp1
         
		 ;    
		 ldi temp2, eep_min_falling
		 rcall EEPROM_write
         
		 ;  " "
		 ldi temp1, CH_t
		 sts Display_Buf+0, temp1

		 lds temp1, OFF_Delay
		 sts Inc_Value_Buf, temp1
		 rcall put_2u

         ldi temp1, MIN_VAL_DELAY
		 sts Inc_Value_Min, temp1

		 ldi temp1, MAX_VAL_DELAY
		 sts Inc_Value_Max, temp1

Btn2_menu_end:

ret
;-------------   3-  (+)--------------------------
Btn3:
         push temp1
		 push temp2
		 push temp3


		 lds temp2, btn_inc_cnt
         cpi temp2, 0
		 brne Btn3_end
         
		 ldi temp2, BTN_INC_FAST_PERIOD

		 lds temp1, btn_fast_inc_cnt
		 cpi temp1, BTN_FAST_INC
		 brsh Btn3_0
		 ldi temp2, BTN_INC_PERIOD
		 inc temp1
		 sts btn_fast_inc_cnt, temp1
Btn3_0:
        ;---,     --- 		 

		 lds temp1, Inc_Value_Buf
		 lds temp3, Inc_Value_Max

		 inc temp1                   ; 
		 cp temp1, temp3         
		 brlo btn_inc_no_max         ;   ,		 
		 lds temp1, Inc_Value_Min    ;    
		                             ;      
         clr temp3
		 sts btn_fast_inc_cnt, temp3 ;   ,
		 ldi temp2, BTN_INC_PERIOD   ;    99->0
		                    		 ;  
btn_inc_no_max:

		 sts Inc_Value_Buf, temp1 ;   

		 rcall put_2u          ;    

        ;----------------------------------------------------------
Btn3_end:
         
         dec temp2
		 sts btn_inc_cnt, temp2

         pop temp3
		 pop temp2		 
		 pop temp1

ret

;-----------------------------  194 --------------------------------
DeadTimeDelay:
         push temp1

		 ldi temp1, 0xFF
DeadTimeDelay_0:
		 dec temp1
		 brne DeadTimeDelay_0

		 pop temp1
ret

;-----------     7- ----------
;    temp1
;    temp1
Decoder:
		 push r0

         ldi ZL,Low(seg7_DC*2)   ; 
         ldi ZH,High(seg7_DC*2)

         clr r0                ; 
         add ZL,temp1            ; 0-  
         adc ZH,r0

         lpm                     ; 
         mov temp1,r0
         
		 pop r0
ret
;---------   7- -----------
seg7_Display:
         
		 push temp1
		 push temp2
		 push YL
		 push YH
         
		 ;   
         ldi temp1,(0xFF<<DIGITS)&0xFF
         in temp2,SEG7_ANOD
         and temp1,temp2
         out SEG7_ANOD,temp1
         
		 ;     
		 rcall DeadTimeDelay
         
		 ;   
		 ldi YL,Low(Display_Buf)
		 ldi YH,0
         add YL,digit

         ld temp1,Y          ;    
         out SEG7_PORT,temp1 ;   


		 ldi temp1,(~(0xFF<<DIGITS)&0xFF)
         and temp1,temp2
		 lsl temp1
		 tst digit
		 brne seg7_Displ_1
		 ldi temp1,0x01
seg7_Displ_1:
		 andi temp2,(0xFF<<DIGITS)&0xFF
		 or temp1,temp2
		 out SEG7_ANOD,temp1

		 
		 
		 pop YH
		 pop YL
		 pop temp2
		 pop temp1
ret

;-----------------    - -----------------
;     temp1
;     temp2  ,
;   temp1 -  .

bin2bcd:
         clr  temp2
bin2bcd_0:
         subi temp1,10
         brmi bin2bcd_1
         inc temp2
         rjmp bin2bcd_0
bin2bcd_1:
         subi temp1,-10
         ;add  temp2,temp1
ret
;-------   2-    ---------
;     R16
put_2u:
         push R17
		 push R18

		 rcall bin2bcd           ;   
		                         ; - 
		                         ;(  R16,  -  R17)
		 
		 rcall Decoder           ;    7-. 
		 
		 ldi R18, F_POINT_DIG_0  ;,    
		 and R18, flags
		 breq put_2u_no_point

		 andi R16, 0b01111111    ; ,   ""

put_2u_no_point:

		 sts Display_Buf+2, R16  ;    
		 mov R16, R17
         rcall Decoder           ;    7-. 
		 sts Display_Buf+1, R16  ;         

		 pop R18
		 pop R17
ret

;----------------------------   N -----------------------------
;    temp1,   -  temp2
;  temp1
Shift_L_N:
         tst temp2
		 breq Shift_L_N_0
		 lsl temp1
		 dec temp2
		 rjmp Shift_L_N
Shift_L_N_0:         
ret

;-----------------------   -----------------------
Debounce:
         push temp1
		 push temp2
		 push temp3
		 push YL
		 push YH

         ;    (  temp1)
		 mov temp2,digit
		 ldi temp1,1
		 rcall Shift_L_N

		 ;    
		 ldi YL,Low(debounce_cnts)
	     ldi YH,0
         add YL,digit
         ld temp3,Y
         
	     ;   
	     sbis BTN_PORT, BTN_PORT_PIN
         rjmp debounce_1
         
		;          
	     cpi temp3, MAX_BNC_CNT
		 brsh debounce_0
         inc temp3                   ;     ,
		                             ;   1.
         rjmp debounce_2
debounce_0:                          
         ;,   :
         icall ;    
         ;rcall Btn3
		 ;   
		 or btn_flags, temp1
		 
		 rjmp debounce_2		         

debounce_1:
        ;    
		 mov temp2, btn_flags
		 and temp2,temp1
         breq debounce_2   ;   ,    (   )
         dec temp3         ;,    1 
		 tst temp3         ;,     
		 brne debounce_2    
         
		 ;   ,     
		 ;   
		 com temp1
         and btn_flags,temp1

		 ;---------,    --------
         clr temp1
   		 sts btn_inc_cnt, temp1
		 sts btn_fast_inc_cnt, temp1

         ;------------------------------------------------------------
debounce_2:
         st Y, temp3

         pop YH
		 pop YL
		 pop temp3
		 pop temp2
		 pop temp1
ret

;--------  24-   16  --------------
div_u24_u16:
        push temp4
     	
        clr	mod0		
		clr	mod1		
		ldi	temp4,24		
					
		lsl	temp1		
		rol	temp2		
		rol	temp3		
		
		rol	mod0		
		rol	mod1		
		
		cp	mod0,temp5	
		cpc	mod1,temp6	
		
		brcs	PC+4		
		inc	temp1		
		sub	mod0,temp5	
		sbc	mod1,temp6	
		
		dec	temp4		
		brne	PC-12	

		pop temp4
ret

;--------------------- 16- ----------------------------
mul16u:		
        push temp7
		
		sub	temp4,temp4	
		sub	temp3,temp3	
		ldi	temp7,17		
		brcc	PC+3		
		add	temp3,temp5	
		adc	temp4,temp6	
		ror	temp4		
		ror	temp3		
		ror	temp2		
		ror	temp1		
		dec	temp7		
		brne	PC-8

		pop temp7
ret

;---------------------------   ----------------------------------
;     R16
;     R17
EEPROM_write:
        push R0
        
	   ;,      
	   ;   
		mov R0, R16
		rcall EEPROM_read
		cp R16,R0           ;     ,
		breq EEPROM_write_1 ;  
		mov R16,R0
       
	   ;  
EEPROM_write_0:		
		sbic EECR, EEPE ;   
		rjmp EEPROM_write_0

		clr R0
		out EECR, R0   ;  
        
		cli             ; 

		out EEARL, R17  ;    

		out EEDR, R16   ;    
		
		sbi EECR, EEMPE ;  EEMPE
		sbi EECR,EEPE   ;   

		sei             ; 

EEPROM_write_1:
		pop R0
ret

;---------------------------   ----------------------------------
;     R17
;     R16
EEPROM_read:
        sbic EECR,EEPE
		rjmp EEPROM_read  ;   

		out EEAR, R17     ; 
		sbi EECR,EERE     ; 

		in R16,EEDR       ; 
ret

;----------------------    ------------------------------
Algorithm:

	    ;  
		rcall Humidity_meas

        
        BLINK_POINT          ;   
		                     ;    
        
       ;    
       ; humidity>100%  humidity<0,   
        lds temp1, humidity
		cpi temp1, 101
		brge humidity_failed
		cpi temp1, 0
        brlt humidity_failed  

;-----------------
	   ; (  ),      ?
       ;(humidity  temp1)
		lds temp2, high_H
        cp temp1,temp2
		brlo no_high_H
		; ,
        ;   
        ori flags, F_TIMER_DISABLE
        ; 
        rcall Load_ON
		;   
		ldi temp2, LED_RED
		out LED_PORT, temp2
		;  
		rcall Reset_Timer
		
		rjmp Alg_end		        
no_high_H:
        ;   ?
        lds temp2, low_H
		cp temp1, temp2
		brsh no_low_H

		; ,   
		lds temp2, OFF_Timer_Val
		tst temp2
		brne Alg_no_off_timer
        rcall Load_OFF
Alg_no_off_timer:
		;   
		ldi temp2, LED_GREEN
		out LED_PORT, temp2
		;   ( )
        andi flags, ~F_TIMER_DISABLE

        ;  
		;rcall Reset_Timer

		;  
		ldi temp2, 0xFF
		sts target_H, temp2

        rjmp Alg_end
no_low_H:

       ;       
	   ;    
		ldi temp2, F_AUTO_MD_LOAD
		and temp2, flags
		breq no_target_H
	   ;   ,
       ;---  ?---
	    lds temp2, humidity
		lds temp3, target_H
		
		;   
		;(      
		;   ),
		;   
		cpi temp3,0xFF
		breq no_target_H

		;, ,    :
		;inc temp3
		subi temp2, TRG_H_HYSTERESIS
        cp temp3, temp2          ;humidity > target_H + TRG_H_HYSTERESIS ?
		brlo no_target_H
        
		; , 
        ;   ( )
        andi flags, ~F_TIMER_DISABLE
        ; 
        rcall Load_OFF
		;  
		ldi temp2, 0xFF
		sts target_H, temp2
        ;   
		ldi temp2, LED_GREEN
		out LED_PORT, temp2
		;  
		rcall Reset_Timer 
no_target_H:   
      

humidity_failed:

Alg_end:

       ; 
        rcall OFF_Tmr		

ret


;-------------------------  ----------------------------
Humidity_meas:
        
		;--------------------------    -----------------
		;  1
		ldi temp1, 0
		out TCCR1B, temp1         
        
		;     
	    in temp5,TCNT1L ;5767
	    in temp6,TCNT1H

		;    1
		out TCNT1H, temp1
		out TCNT1L, temp1

		;  1   
		ldi temp1, 0x07
		out TCCR1B, temp1

		
		
		;  
		ldi temp1, 4
		ldi temp2, 0
		cp temp5, temp1
		cpc temp6, temp2
		brsh Humidity_meas_1

		;   , humidity=101
		ldi temp1, 101
		rjmp Humidity_meas_end

Humidity_meas_1:
	   	 

       	
	   ;*******************************************************
	    ;frequency=[temp6:temp5]
		;   : 
		;  temp1, temp2, temp3, temp4, YL, YH

		;  
		;       ?
	    lds temp1, humidity
	    tst temp1 
	    brne HM_no1st
        ; ,    H_array
	    ;   
        ldi temp1, 8         
	    ldi YL,Low(H_array)
	    ldi YH,0
HM_init_ary:		
	    st Y+, temp5
		st Y+, temp6
	    dec temp1
	    brne HM_init_ary

HM_no1st: ;      
       
	  ;                
       ;      
       lds temp1, H_array_i
       ldi YL,Low(H_array)
	   ldi YH,0
       add YL, temp1
       st Y+, temp5
	   st Y, temp6
       ;     16
       inc temp1
	   inc temp1
	   andi temp1, 0b00001111
       sts H_array_i, temp1

      ; 
       
	   ;    
	   ldi temp4, 8         ; 
	   ldi YL,Low(H_array)  ;  Y-   
	   ldi YH,0
       ;   
	   clr temp3            ;     
       clr temp6            ;            
       clr temp5            ;  	   
HM_avrg_summ:			   
       ld temp1, Y+         ;    
	   ld temp2, Y+
       add temp5, temp1     ;  
       adc temp6, temp2
	   adc temp3, YH     
	   
	   dec temp4
	   brne HM_avrg_summ
       
	   ; 
	   ;(    "4")
	   subi temp5, -4
	   sbci temp6, 0xFF
	   sbci temp3, 0xFF
           
       ;   8 (   3 )
       ldi temp1, 3        ; 
HM_avrg_dev8:           
             
	   lsr temp3
	   ror temp6
	   ror temp5

       dec temp1
       brne HM_avrg_dev8
      ;*****************************************************************
	  
	  	 		 
      ;-------------------------   ----------------------------- 
	  ;humidity=(((10000000L/frequency)*K_SENS)/1000 - H_offs),
	  ; frequency -   (  temp6:temp5)
	  ;    humidity  - ,   temp1
                
       ;  10 000 000
	   ldi temp1,0x80       
	   ldi temp2,0x96
	   ldi temp3,0x98
	   	   	   
	   rcall div_u24_u16 

       ;      
	   lds temp5,K_SENS
	   lds temp6,K_SENS+1

	   rcall mul16u
      
	   ;  1000
       ldi temp5,0xE8 
	   ldi temp6,0x03

	   rcall div_u24_u16

	   lds temp5, H_offs
	   lds temp6, H_offs+1
       
	   sub temp1,temp5
	   sbc temp2,temp6
	   
	   brpl Humidity_meas_chk_1      
	   ;  , humidity=-1
       ldi temp1, -1
       rjmp Humidity_meas_end

Humidity_meas_chk_1:
       ;humidity<100?
       ldi temp5,100
	   ldi temp6,0
	   cp temp1, temp5
	   cpc temp2, temp6
	   brlo Humidity_meas_end

	   ldi temp1, 100 ; humidity>=100,  humidity:=100	   

Humidity_meas_end:
                              
       ;     
	   sts humidity, temp1

ret
;-----------------------   -----------------------
Display_mode:
       push temp1
	   
	   ;      

	   
	   lds temp1, mode
	   cpi temp1, MD_AUTO_MODE
	   brne displ_no_auto_md
      
	  ;  :

	   ;--
	   ;     ,
	   lds temp1, Ext_Control_cnt
	   cpi temp1, NO_EXT_SIGNAL
	   brsh displ_ext_ctrl

	   ;     humidity
	   ;  
	   lds temp1, humidity
	   cpi temp1, -1
	   brne displ_no_Low_H

	   ;  "-1",  "ErL"
	   ldi temp1, CH_E
	   sts Display_Buf+0,temp1
	   ldi temp1, CH_r
	   sts Display_Buf+1,temp1
	   ldi temp1, CH_L
	   sts Display_Buf+2,temp1

	   rjmp Display_mode_end

displ_no_Low_H:
       cpi temp1, 100
	   brne displ_no_High_H
	          
       ;    99,  "100"
       ldi temp1, CH_1
	   sts Display_Buf+0,temp1
	   ldi temp1, CH_O
	   sts Display_Buf+1,temp1
	   ldi temp1, CH_O
	   sts Display_Buf+2,temp1
       
	   rjmp Display_mode_end

displ_no_High_H:
       
	   cpi temp1, 101
	   brne no_sensor_failed

       ldi temp1, CH_HYPHEN    ;  "---"
	   sts Display_Buf+0,temp1
	   sts Display_Buf+1,temp1
	   sts Display_Buf+2,temp1

       rjmp Display_mode_end

no_sensor_failed:

	   ;     
	   ldi temp1,CH_SPACE   
	   sts Display_Buf,temp1  ;   

	   lds temp1, humidity
	   rcall put_2u           ;   

	   rjmp Display_mode_end

displ_ext_ctrl:
       ;    ,
	   ;   "."
	   ldi temp1, CH_3
	   sts Display_Buf, temp1
	   ldi temp1, CH_A
   	   sts Display_Buf+1, temp1
	   ldi temp1, CH_Hp
	   sts Display_Buf+2, temp1

       rjmp Display_mode_end

displ_no_auto_md:

      ;  :

       sbis LOAD_PORT, LOAD_PIN
	   rjmp displ_load_off

       ldi temp1, CH_O
	   sts Display_Buf, temp1
	   ldi temp1, CH_n
   	   sts Display_Buf+1, temp1
	   ldi temp1, CH_SPACE
	   sts Display_Buf+2, temp1

	   rjmp Display_mode_end

displ_load_off:
       ldi temp1, CH_O
	   sts Display_Buf, temp1
	   ldi temp1, CH_F
   	   sts Display_Buf+1, temp1
	   sts Display_Buf+2, temp1

Display_mode_end:
	   
	   pop temp1
ret
;---------------------------- -------------------------------
Vent_Control:
        push temp1
		push temp2
		push temp3

       ;------- --------

		lds temp3, humidity ;  temp3  
		lds temp2, prev_H   ;  temp2 -   
		lds temp1, high_H

		tst temp2
		brne no_first
		
		;     
		; prev_H   
        mov temp2, temp3
no_first:

        ; -    
        sub temp3, temp2    ; 
		sts dH_dt, temp3    ;    dH_dt

	   ;----  ?-----
		lds temp2, max_raising
		cp temp3, temp2
		brlt no_max_raising

		;   
		ldi temp2, LED_RED
		out LED_PORT, temp2

		;   
        ori flags, F_TIMER_DISABLE

		;  
		rcall Reset_Timer       

		;,     ?
		lds temp2, target_H
		cpi temp2, 0xFF
		brne no_max_raising

        ;  ,
		;    
		; ?
		lds temp2, prev_H
        cp temp2, temp1
		brge no_max_raising
		
		;  ,
		;  ,
		;      .
		;     
		sts target_H, temp2

		; 
        rcall Load_ON
        
        rjmp Vent_Cnt_end

no_max_raising:
        
	   ;------- ?------	
		ldi temp2, F_AUTO_MD_LOAD
		and temp2, flags
		breq Vent_Cnt_end

	   ;--- ,  ?---
		cpi temp3,-1
		brge no_H_falling

		;,    ?
		lds temp2, humidity
		cp temp2, temp1
		brsh no_H_falling

		;       ,
		;   
		ldi temp2, LED_YELLOW
		out LED_PORT, temp2    
no_H_falling:
        
	   ;---    ?---      
        lds temp2, min_falling
		neg temp2
		cp temp3, temp2
		brge no_min_falling
		
		; ,     :
		
		;   
		ldi temp2, F_H_MIN_FALLING
		and temp2, flags
		brne no_min_falling
		;  ,
        ;   ( )
        andi flags, ~F_TIMER_DISABLE
		; 
		rcall Start_Timer
		; 
		ori flags, F_H_MIN_FALLING

 no_min_falling:

vent_turned_off:

Vent_Cnt_end:       
	   lds temp3, humidity
	   sts prev_H, temp3   ;   
	    
	   pop temp3
	   pop temp2
	   pop temp1
	   

ret

;--------------------------------- -----------------------------------
Start_Timer:
        push temp1
        
        ;,    ?
        ldi temp1, F_TIMER_DISABLE
        and temp1, flags
        brne timer_started
        ; ,
		;    
		lds temp1, OFF_delay
		sts OFF_Timer_Val, temp1

		ldi temp1, 0
		sts tmr_seconds, temp1

		;  
		ori flags, F_OFF_TMR_ELAPS
timer_started:

        pop temp1
ret

;--------------------------------- ------------------------------------
Reset_Timer:
        push temp1
        
		
		ldi temp1, 0
		sts OFF_Timer_Val, temp1       ; 

        ;       
        andi flags, ~(F_OFF_TMR_ELAPS|F_H_MIN_FALLING)

		pop temp1
ret

;----------------------------  ----------------------------
OFF_Tmr:
        push temp2
		push temp3        

		lds temp2, OFF_Timer_Val
		tst temp2
		breq no_off_timer
		;     ( ),
				
		;  
		lds temp3, tmr_seconds
		inc temp3
        
		;,   1 
		cpi temp3, MINUTE
		brlo no_off_tmr_elaps

        ;  1 ,   :
		
		clr temp3              ;  
				 
		;   
        dec temp2
		sts OFF_Timer_Val, temp2
		rjmp no_off_tmr_elaps
no_off_timer:
       
        ;   = 0,
		;   
		ldi temp2, F_OFF_TMR_ELAPS
        and temp2,flags		
		breq no_off_tmr_elaps
		;   ( ,   ),
		rcall Load_OFF                 ; 
		ldi temp2, LED_GREEN           ;  
		out LED_PORT, temp2
		;   
		ldi temp2, 0xFF
		sts target_H, temp2
		
        ;       
        andi flags, ~(F_OFF_TMR_ELAPS|F_H_MIN_FALLING)

no_off_tmr_elaps:
        
		sts tmr_seconds, temp3

		pop temp3
		pop temp2    
ret

;----------- ------------
WD_timeout:
		push temp2

		lds temp2, timeout_cnt
        ;,    
        cpi temp2, 0xFF
        breq no_timeout
        ; ,    1
        dec temp2        
        ;  ,
        brne no_timeout
        rcall Load_OFF   ; 
		;   ( )
        andi flags, ~F_TIMER_DISABLE
		;   
		ldi temp2, LED_GREEN
		out LED_PORT, temp2
no_timeout:
        sts timeout_cnt, temp2

		pop temp2
ret
;----------------------------- --------------------------------
Load_ON:
		push temp1       

        ;,       ?
		ldi temp1, F_EXT_CTRL		
        and temp1,flags
		brne Ld_ON_1      ;  ,     
		                  ;-       
        ;   ,   
		lds temp1, timeout
        sts timeout_cnt, temp1
Ld_ON_1:
        ori flags, F_AUTO_MD_LOAD

        pop temp1
ret

;----------------------------- -------------------------------
Load_OFF:
		push temp1

        ldi temp1,0xFF
        sts timeout_cnt, temp1

        andi flags, ~F_AUTO_MD_LOAD

        pop temp1
ret

;-----------------   A 0- -----------------
Timer0_compA:
       
    push temp1
	in temp1, SREG
	push temp1

	ori flags, F_TIMER0_INT
	
	pop temp1
	out SREG, temp1
	pop temp1    

reti

;----------------------   INT1-------------------------
INT_1:
    push temp1
	in temp1, SREG
	push temp1
   
	lds temp1, Ext_Control_cnt
	cpi temp1, EXT_CTRL_CNT
	brsh INT_1_end
	inc temp1

	sts Ext_Control_cnt, temp1
INT_1_end:	
    
	pop temp1
	out SREG, temp1
    pop temp1    
reti
